Difference between revisions of "Mesh Scripting/fr"

From FreeCAD Documentation
Jump to navigation Jump to search
Line 59: Line 59:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
 
 
Ce script fournit les méthodes pour construire des figures simples qui ont besoin d'une rotation comme des sphères, ellipsoïdes, cylindres, tores et cônes. Il existe aussi une méthode pour créer un simple cube.<br />
 
Ce script fournit les méthodes pour construire des figures simples qui ont besoin d'une rotation comme des sphères, ellipsoïdes, cylindres, tores et cônes. Il existe aussi une méthode pour créer un simple cube.<br />
Pour créer un tore, par exemple, nous ferons :
+
Un tore, par exemple, peut être créé comme suit:
</div>
 
  
 
{{Code|code=
 
{{Code|code=

Revision as of 13:41, 31 May 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文(中国大陆)‎
Arrow-left.svg Page précédente : Débuter avec les scripts
Page suivante : Script pour des pièces Arrow-right.svg

Introduction

Vous devez tout d'abord importer le module Mesh:

import Mesh

Dès que vous avez importé le module de maillage de la classe Mesh, vous accéderez facilitent aux fonctions C++ Mesh-Kernel de FreeCAD.

Création et chargement

Pour créer un objet maillage vide il suffit d'utiliser la commande standard :

mesh = Mesh.Mesh()

Vous pouvez aussi créer un objet à partir d'un fichier

mesh = Mesh.Mesh('D:/temp/Something.stl')

(Une liste de fichiers compatibles avec "Mesh" (maillage) est disponible ici).

ou créer un ensemble de triangles en les décrivant par leurs sommets (Vertex) :

planarMesh = [
# triangle 1
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
#triangle 2
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)

Le Mesh-Kernel prend soin de créer une structure de données topologiquement correcte en triant les points et les bords coïncidents.

Plus tard, vous verrez comment tester et examiner les données de maillage.

En haut

Modélisation

Pour créer des formes géométriques, vous pouvez utiliser le script Python BuildRegularGeoms.py.

import BuildRegularGeoms

Ce script fournit les méthodes pour construire des figures simples qui ont besoin d'une rotation comme des sphères, ellipsoïdes, cylindres, tores et cônes. Il existe aussi une méthode pour créer un simple cube.
Un tore, par exemple, peut être créé comme suit:

t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)

Les deux premiers paramètres définissent les rayons du tore, et le troisième paramètre est un facteur de sous-échantillonnage pour le nombre de triangles qui seront créés. Plus cette valeur est élevée plus la figure sera lisse et plus cette valeur est basse plus grossière sera la figure.
La classe Mesh offre un ensemble de fonctions booléennes qui peuvent êtres utilisées à des fins de modélisation. Il fournit l'union, l'intersection et la différence entre deux objets maillés.

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Et ici, un exemple complet qui calcule l'intersection entre une sphère et un cylindre qui coupe la sphère.

import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh(BuildRegularGeoms.Sphere(5.0, 50))
cylinder = Mesh.Mesh(BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50))
diff = sphere
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature", "Diff_Sphere_Cylinder").Mesh = diff
d.recompute()

top

Exporter

Vous pouvez même écrire votre modèle de maillage dans un module Python :

m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)

top

Quelques points en plus

Une extension (difficile à utiliser) de scripts Mesh qui est à tester. Dans cette compilation test, toutes les méthodes sont appelées et toutes les propriétés et attributs sont manipulés. Donc, si vous êtes assez audacieux, jetez un œil au module de test unitaire.

Voir aussi Mesh API

top

Arrow-left.svg Page précédente : Débuter avec les scripts
Page suivante : Script pour des pièces Arrow-right.svg